
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program DeplGraphe;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

var
  AngleFleche : integer;
  Ch : char;
  Fleche : PlotArray;
  XCour, YCour, IncrX, IncrY, Taille, Vitesse : Float;
  IncrFleche : array[0..7, 1..2] of Float;

procedure FaisFleche;
begin
  Fleche[1, 1] := 0;		   { Init PlotArray pour tte de flche }
  Fleche[1, 2] := 0;
  Fleche[2, 1] := Taille;
  Fleche[2, 2] := -Taille;
  Fleche[3, 1] := 0;
  Fleche[3, 2] := Taille;
  Fleche[4, 1] := -Taille;
  Fleche[4, 2] := -Taille;
  Fleche[5, 1] := 0;
  Fleche[5, 2] := 0;
end; { FaisFleche }

procedure FaisTableDeplacements;
begin
  IncrFleche[0, 1] := 0;	   { Rapidit composants pour }
  IncrFleche[0, 2] := 1;	   { mouvements radiaux }
  IncrFleche[1, 1] := -1;
  IncrFleche[1, 2] := 1;
  IncrFleche[2, 1] := -1;
  IncrFleche[2, 2] := 0;
  IncrFleche[3, 1] := -1;
  IncrFleche[3, 2] := -1;
  IncrFleche[4, 1] := 0;
  IncrFleche[4, 2] := -1;
  IncrFleche[5, 1] := 1;
  IncrFleche[5, 2] := -1;
  IncrFleche[6, 1] := 1;
  IncrFleche[6, 2] := 0;
  IncrFleche[7, 1] := 1;
  IncrFleche[7, 2] := 1;
end; { FaisTableDeplacements }

procedure DeplAvant;		     { Routine dplacement avant }
begin
  SetColorBlack;		       { Dessin sur l'ancien graphe }
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
  XCour := XCour + IncrX;	       { Dplacement vers nouvelle position }
  YCour := YCour + IncrY;
  TranslatePolygon(Fleche, 5, IncrX, IncrY);
  SetColorWhite;		      { Dessin graphe sur nouvelle position }
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
end; { DeplAvant }

procedure DeplArriere;			  { Routine dplacement arrire }
begin
  SetColorBlack;		       { Voir au dessus }
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
  XCour := XCour - IncrX;
  YCour := YCour - IncrY;
  TranslatePolygon(Fleche, 5, -IncrX, -IncrY);
  SetColorWhite;
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
end; { DeplArriere }

procedure TourneGauche;			   { Rotation inverse des aiguilles }
begin				       { d'une montre                   }
  SetColorBlack;		       { Efface ancien graphe }
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
  RotatePolygon(Fleche, 5, 45);		{ Rotatiion 45 degrs }
  AngleFleche := AngleFleche + 1;
  if AngleFleche > 7 then
    AngleFleche := 0;
  IncrX := Vitesse * IncrFleche[AngleFleche, 1];  { Nouvelle vitesse }
  Incry := Vitesse * IncrFleche[AngleFleche, 2];
  SetColorWhite;		       { Dessin graphe }
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
end; { TourneGauche }

procedure TourneDroite;			  { Rotation sens des aiguilles }
begin				       { d'une montre                }
  SetColorBlack;		       { Voir au dessus }
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
  RotatePolygon(Fleche, 5, -45);
  AngleFleche := AngleFleche - 1;
  if AngleFleche < 0 then
    AngleFleche := 7;
  IncrX := Vitesse * IncrFleche[AngleFleche, 1];
  Incry := Vitesse * IncrFleche[AngleFleche, 2];
  SetColorWhite;
  DrawPolygon(Fleche, 1, -5, 0, 0, 0);
end; { TourneDroite }


begin
  InitGraphic;			       { Initialise le systme graphique }

  DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb);

  DefineWorld(1, -1000, -1000, 1000, 1000);{ Dfinit un systme       }
					   { de coordonnes relatives }

  SelectWorld(1);		       { Choisit le repre    }
  SelectWindow(1);		       { Choisit la fentre   }
  SetBackground(0);		       { Dfinit un fond noir }

  Taille := 100;
  Vitesse := 30;
  XCour := 0;
  YCour := 0;
  AngleFleche := 0;
  IncrX := 0;
  IncrY := Vitesse;

  FaisFleche;			       { Construit tte de flche     }
  FaisTableDeplacements;	       { Construit table dplacements }
  DrawPolygon(Fleche, 1, 5, 0, 0, 0);	{ Dessine pointe vers le haut  }

  repeat
    Ch := ReadKey;		       { Lit la frappe au clavier     }

    if (Ch = #0) and KeyPressed then   { Test code balayage tendu    }
      Ch := ReadKey;		       { pour IBM ou Zenith Z100      }
    case Ch of
      'A', 'H' : DeplAvant;	       { Flche haut   }
      'D', 'K' : TourneGauche;	       { Flche gauche }
      'C', 'M' : TourneDroite;	       { Flche droite }
      'B', 'P' : DeplArriere;	       { Flche bas    }
    end;
  until Ch = ' ';		       { Le caractre espace }
				       { sort du programme   }

  LeaveGraphic;			       { Quitte le systme graphique }
end. { DeplGraphe }
