
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program ESEcran;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel;

procedure Sierpinski;
const
  N = 5;
var
  I, H, X, Y, X0, Y0 : integer;
  Sec : boolean;

procedure Allume;			 { Dessine une ligne }
begin
  DrawLine(X, Y, X0, Y0);
  X0 := X;
  Y0 := Y;
end;

procedure B(I:integer); forward;       { Rfrences Forward pour rcursion }

procedure C(I:integer); forward;

procedure D(I:integer); forward;

procedure A(I : integer);	       { Premire procdure rcursive }
begin
  if I > 0 then
  begin
    A(I - 1);
    X := X + H;
    Y := Y - H;
    Allume;
    B(I - 1);
    X := X + 2 * H;
    Allume;
    D(I - 1);
    X := X + H;
    Y := Y + H;
    Allume;
    A(I - 1);
  end;
end; { A }

procedure B;			       { Seconde procdure rcursive }
begin
  if I > 0 then
  begin
    B(I - 1);
    X := X - H;
    Y := Y - H;
    Allume;
    C(I - 1);
    Y := Y - 2 * H;
    Allume;
    A(I - 1);
    X := X + H;
    Y := Y - H;
    Allume;
    B(I - 1);
  end;
end; { B }

procedure C;			       { Troisime procdure rcursive }
begin
  if I > 0 then
  begin
    C(I - 1);
    X := X - H;
    Y := Y + H;
    Allume;
    D(I - 1);
    X := X - 2 * H;
    Allume;
    B(I - 1);
    X := X - H;
    Y := Y - H;
    Allume;
    C(I - 1);
  end;
end; { C }

procedure D;			       { Dernire procdure rcursive }
begin
  if I > 0 then
  begin
    D(I - 1);
    X := X + H;
    Y := Y + H;
    Allume;
    A(I - 1);
    Y := Y + 2 * H;
    Allume;
    C(I - 1);
    X := X - H;
    Y := Y + H;
    Allume;
    D(I - 1);
  end;
end; { D }

procedure Fais;			       { Procdure principale Sierpinski }
begin
  I := 3;
  H := 16;
  X0 := 30;
  Y0 := 240;
  repeat
    I := I + 1;
    X0 := X0 - H;
    H := H div 2;
    Y0 := Y0 + H;
    X := X0;
    Y := Y0;
    A(I - 1);
    X := X + H;
    Y := Y - H;
    Allume;
    B(I - 1);
    X := X - H;
    Y := Y - H;
    Allume;
    C(I - 1);
    X := X - H;
    Y := Y + H;
    Allume;
    D(I - 1);
    X := X + H;
    Y := Y + H;
    Allume;
  until I = N;
end; { Fais }

begin
  SetHeaderOn;
  DefineWorld(1, -3, -3, 258, 258);
  SelectWorld(1);
  SelectWindow(1);
  DrawBorder;
  Fais;
end; { Sierpinski }

begin
  InitGraphic;			       { Initialise le systme graphique }

  DefineHeader(1, 'DEMONSTRATION DE SAUVEGARDE ET DE RELECTURE D''ECRAN SUR DISQUE ');

  SetHeaderOn;			       { Entte }

  Sierpinski;			       { Trace la courbe }

  SaveScreen('DEMO.PIC');	       { Sauve l'cran sur disque }

  ClearScreen;			       { Efface l'cran }

  Delay(1000);			       { Dlai pour utilisateurs de disque
					 dur ou de disque virtuel }

  LoadScreen('DEMO.PIC');	       { Recharge depuis le disque }


  repeat until KeyPressed;	       { Attend la frappe d'une touche }

  ClearScreen;

  LeaveGraphic;			       { Quitte la systme graphique }
end. { ESEcran }
