;********************************************************************
;*			   GRAPHIX TOOLBOX 4.0			    *
;*	   Copyright (c) 1985, 87 Borland International, Inc.	    *
;*								    *
;*   Externes pour module de gestion adaptateur vido IBM 3270 PC   *
;********************************************************************

DATA	 SEGMENT  WORD PUBLIC
	 EXTRN	  ScreenGlb:DWORD, GrafBase:WORD, RamScreenGlb:BYTE
	 EXTRN	  XTextGlb:BYTE, YTextGlb:BYTE, ColorGlb:BYTE, Font:BYTE
DATA	 ENDS

HardwareGrafBase  EQU 0B800H	      ;Segment du buffer d'cran graphique
ScreenSizeGlb	  EQU 16383	      ;Taille de l'cran en mots

CODE	 SEGMENT  BYTE PUBLIC

	 ASSUME   CS:CODE, DS:DATA

	 PUBLIC   DC, DP, SwapScreen, InvertScreen  ;Routines publiques

; procedure DC(C : byte);
; var
;   X, Y, I : integer;
; begin
;   X := XTextGlb-1;
;   Y := (YTextGlb-1) * 14;
;   for I := 0 to 13 do
;     Mem[GrafBase:BaseAddress(Y+I) + X] := Font[C][I];
; end; { DC }

CPtr		  EQU	  BYTE PTR [BP+6]

DC		  PROC FAR

	 PUSH	  BP		  ;Sauve BP
	 MOV	  BP,SP		  ;Init cadre pile
	 MOV	  BL,CPtr
	 XOR	  BH,BH		  ;BX := C
	 MOV	  AX,14
	 MUL	  BX
	 MOV	  BX,AX		  ;BX := C * 14
	 ADD	  BX, OFFSET Font ;BX := Addr(Font[C])
	 MOV	  DL,[XTextGlb]
	 XOR	  DH,DH
	 INC	  DX
	 MOV	  DI,DX		  ;DI := XTextGlb

	 MOV	  DL,[YTextGlb]
	 DEC	  DX		  ;DX := YTextGlb - 1
	 MOV	  AX,14
	 MUL	  DX
	 MOV	  DX,AX		  ;DX := (YTextGlb-1) * 14
	 MOV	  AX,[GrafBase]
	 MOV	  ES,AX		  ;ES := GrafBase
	 MOV	  AX,DX
	 MOV	  CX,90
	 MUL	  CX
	 MOV	  DX,AX		  ;DX := BaseAddress(Y + I)
	 MOV	  CH,14		  ;Boucle 14 fois
Loop:	 MOV	  SI,DX		  ;SI := BaseAddress(Y + I)
	 ADD	  SI,DI		  ;SI := BaseAddress(Y + I) + X
	 MOV	  AL,[BX]	  ;AL := Font[C][I]
	 MOV   ES:[SI],AL	  ;Ecrit morceau de car dans mem
	 INC	  BX		  ;Incrmente offset de fonte
	 ADD	  DX,90		  ;DX := BaseAddress(Y + I)
	 DEC	  CH		  ;Dcrmente compteur de boucle
	 JNZ	  Loop		  ;Si Ch <> zro alors saute  loop:
	 POP	  BP		  ;Restaure BP
	 RET	  2		  ;Enlve paramtres et retourne

DC		  ENDP

; procedure DP(X, Y : word);
; var
;   I : word;
; begin
;   I := BaseAddress(Y) + X shr 3;
;   if ColorGlb = 255 then
;     Mem[GrafBase:I] := Mem[GrafBase:I] or 128 shr (X and 7)
;   else
;     Mem[GrafBase:I] := Mem[GrafBase:I] and ($FF7F shr (X and 7));
; end; { DP }

XPtr		  EQU	  WORD PTR [BP+8]
YPtr		  EQU	  WORD PTR [BP+6]

DP		  PROC FAR

	 PUSH	  BP			   ;Sauve BP
	 MOV	  BP,SP			   ;Init cadre pile
	 MOV	  AX,YPtr		   ;BX := Y
	 MOV	  CX,90
	 MUL	  CX			   ;AX := BaseAddress(Y)
	 MOV	  BX,XPtr		   ;BX := X
	 MOV	  DX,BX
	 MOV	  CL,03
	 SHR	  BX,CL			   ;BX := X shr 3
	 ADD	  BX,AX			   ;BX := BaseAddress(Y) + (X shr 3)
	 MOV	  CL,DL
	 AND	  CL,07			   ;CL := X and 7
	 MOV	  DL,80H		   ;DL := 128
	 SHR	  DL,CL			   ;DL := 128 shr (X and 7)
	 MOV	  ES,[GrafBase]		   ;ES := base de l'cran graphique
	 CMP	  BYTE PTR [ColorGlb],0FFH ;ColorGlb = 255 ?
	 JNZ	  AndBit
	 OR    ES:[BX],DL		   ;OUI : OR le bit sur l'cran
	 JMP	  Done
AndBit:  NOT	  DL			   ;NON : Inverse les bits dans DL
	 AND   ES:[BX],DL		   ;	  AND le bit  l'cran
Done:	 POP	  BP			   ;Restaure BP
	 RET	  4			   ;Enlve paramtres et retourne

DP		  ENDP

; procedure SwapScreen;
; { Echange le contenu de l'cran affich }
; { avec le contenu de l'cran virtuel    }
; const
;   HardwareGrafBase = $B800;
; var
;   ScanLine,
;   LineBase,
;   RamScrSeg  : word;
;   LineBuffer : array[0..XMaxGlb] of byte;
; begin
;   if RamScreenGlb then
;   begin
;     RamScrSeg := Seg(ScreenGlb^);
;     for ScanLine := 0 to YMaxGlb do
;     begin
;	LineBase := BaseAddress(Scanline);
;	Move(Mem[HardwareGrafBase:LineBase], LineBuffer, XMaxGlb+1);
;	Move(Mem[RamScrSeg:LineBase], Mem[HardwareGrafBase:LineBase], XMaxGlb+1);
;	Move(LineBuffer, Mem[RamScrSeg:LineBase], XMaxGlb+1);
;     end;
;   end;
; end; { SwapScreen }

SwapScreen	    PROC FAR

	   PUSH     BP			   ;Sauve BP
	   MOV	    BP,SP		   ;Init cadre pile
	   MOV	    AL,RamScreenGlb	   ;Charge boolen dans AL
	   XOR	    AH,AH		   ;AH <- 0
	   OR	    AX,AX
	   JZ	    JumpOut		   ;Sort si boolen faux
	   LES	    DI,[ScreenGlb]	   ;ES <- Seg(ScreenGlb^)
	   PUSH     DS			   ;Sauve DS
	   MOV	    AX,HardwareGrafBase    ;
	   MOV	    DS,AX		   ;DS <- Seg d'cran matriel
	   MOV	    CX,ScreenSizeGlb	   ;CX <- Taille cran en mots
	   XOR	    BX,BX		   ;BX <- offset mot de zro
SwapWords: MOV	    AX,[BX]		   ;AX <- mot d'cran matriel
	   XCHG     AX,ES:[BX]		   ;AX <-> cran logiciel
	   MOV	    [BX],AX		   ;Ecran matriel <- AX
	   INC	    BX
	   INC	    BX			   ;Incrmente offset mot de 2
	   LOOP     SwapWords		   ;Echange octet suivant
	   POP	    DS			   ;Restaure DS
JumpOut:   POP	    BP			   ;Restaure BP
	   RET				   ;Retourne

SwapScreen	  ENDP

; procedure InvertScreen;
; { Inverse le contenu de la mmoire d'cran }
; var
;   Offset : word;
; begin
;   for Offset := 0 to (16383 shl 1)+1 do
;     Mem[GrafBase:Offset] := Not(Mem[GrafBase:Offset]);
; end; { InvertScreen }

InvertScreen	  PROC FAR

	 PUSH	  BP		      ;Sauve BP
	 MOV	  BP,SP		      ;Init cadre pile
	 PUSH	  DS		      ;Sauve segment de donnes
	 MOV	  AX,[GrafBase]
	 MOV	  DS,AX		      ;DS := adresse de base cran graphique
	 MOV	  CX,ScreenSizeGlb    ;CX := Taille cran en entiers
	 XOR	  BX,BX		      ;Zro hors BX
InvWrd:  NOT	  WORD PTR [BX]       ;Inverse mot en DS:BX
	 INC	  BX
	 INC	  BX		      ;Incrmente pour mot suivant
	 Loop	  InvWrd
	 POP	  DS		      ;Restaure segment de donnes
	 POP	  BP		      ;Restaure BP
	 RET			      ;Retourne

InvertScreen	  ENDP

CODE	 ENDS
	 END








