
{	    Copyright (c) 1985, 87 Borland International, Inc.		  }

program HistoSectoriel;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure DemHistoSectoriel;
var
  Somme, X1, Y1, X2, Y2, RayonInt, RayonExt : Float;
  I, N : integer;
  A : PieArray;
  B : PlotArray;
  Ch : char;
  TexteNum : WrkString;

begin
  N := 5;				 { Nombre de points de donnes }
  A[1].Zone := 25;			 { Initialise intervalle       }
  A[2].Zone := 17.5;
  A[3].Zone := 9.6;
  A[4].Zone := 21;
  A[5].Zone := 35;
  A[1].Text := 'JAN. ';
  A[2].Text := 'FEV. ';
  A[3].Text := 'MAR. ';
  A[4].Text := 'AVR. ';
  A[5].Text := 'MAI  ';

  for I := 1 to N do			  { Init intervalle histogramme }
    B[I, 2] := A[I].Zone;

  ClearScreen;
  SetColorWhite;

  DefineWindow(1, 0, 0, XMaxGlb, YMaxGlb);
  DefineHeader(1, 'HISTOGRAMME ET CAMEMBERT ENSEMBLE');  { Init fentre }
  SelectWindow(1);
  SetHeaderOn;
  SetBackground(0);
  DrawBorder;

  for I := 1 to N do			  { Info dans coin sup. droit }
  begin
    GotoXY(60, 4 + I);			  { Va ligne correcte }
    Write(A[I].Text, '=');		  { Ecrit tiquette info }
    Str(A[I].Zone:6:2, TexteNum);	   { Formate info numrique }
    Write(TexteNum);			   { Ecrit info numrique }
  end;

  DefineWindow(2, Trunc(XMaxGlb / 10), Trunc(YMaxGlb / 10),
		  Trunc(XMaxGlb * 6 / 10), Trunc(YMaxGlb * 7 / 10));
  DefineHeader(2, 'CAMEMBERT');		{ Init fentre }
  DefineWorld(2, 0, 0, 1000, 1000);
  SelectWorld(2);
  SelectWindow(2);
  SetHeaderOn;
  SetBackground(0);
  DrawBorder;

  A[1].Zone := -A[1].Zone;		 { Va au premier segment extrieur }
  SetAspect(1.0);			 { Init ratio aspect }

  X1 := 500;				 { Init centre en milieu d'cran }
  Y1 := 500;

  X2 := 600;				 { Init dbut cercle }
  Y2 := 350;

  RayonInt := 0.7;			 { Init fin ligne }
  RayonExt := 1.25;

  DrawCartPie(X1, Y1, X2, Y2, RayonInt, RayonExt, A, N, 2, 1);
					 { Dessine diagramme }

  A[1].Zone := -A[1].Zone;		 { Rinit signe }

  DefineWindow(3, Trunc(XMaxGlb / 2), Trunc(YMaxGlb / 2),
		  Trunc(XMaxGlb * 9 / 10), Trunc(YMaxGlb * 9 / 10));
  DefineHeader(3, 'HISTOGRAMME');	 { Init fentre }
  DefineWorld(3, 0, 0, 10, 60);
  SelectWorld(3);
  SelectWindow(3);
  SetHeaderOn;
  SetBackground(0);
  DrawBorder;

  DrawHistogram(B, N, true, 5);

  for I := 1 to N do			 { Dessine titres histogramme }
  begin
    DrawTextW((10 / N) * (I - 1), 10, 1, '   ' + A[I].Text); { Dessine texte }
    Str(A[I].Zone:6:2, TexteNum);			      { Formate le nombre }
    DrawTextW((10 / N) * (I - 1), 16, 1, ' ' + TexteNum);     { Dessine le nombre }
  end;
end; { DemHistoSectoriel }

begin { HistoSectoriel }
  InitGraphic;				 { Initialise le systme graphique }

  DemHistoSectoriel;			 { Excute dmo }

  repeat until KeyPressed;		 { Attend la frappe d'une touche }

  LeaveGraphic;				 { Quitte systme graphique }
end. { HistoSectoriel }

