(********************************************************************)
(*			   GRAPHIX TOOLBOX 4.0			    *)
(*	   Copyright (c) 1985, 87 Borland International, Inc.	    *)
(*								    *)
(*			 Programme de dmonstration		    *)
(********************************************************************)

program DemoGraphiquesTurbo;

{$I Float.inc}	{ Dtermine le type Float. }

uses
  Dos, Crt, GDriver, GKernel, GWindow, GShell;

procedure Delay(N : Float);
var
  I : Float;
  J : integer;
  Ch : char;
  Quitte : boolean;

begin
  I := 0;
  Ch := ' ';
  repeat
    I := I + 1;
    Quitte := false;
    if KeyPressed then
    begin
      Ch := ReadKey;
      Quitte := (Ch = ^C);
      if (Ch = '') and KeyPressed then
      begin
	Ch := ReadKey;
	Quitte := (Ch = 'O');
	Ch := ' ';
      end;
    end;
    if Quitte then
    begin
      LeaveGraphic;
      Halt;
    end;
  until (Ch = ^M) or (I >= N);
end; { Delay }

procedure AttendReturn(N : Float);
begin
  Write('Tapez RETURN pour continuer');
  Delay(N);
end; { AttendReturn }

procedure EffaceFin(I : integer);
begin
  GotoXY(1, I);
  Write('                                                                               ');
end; { EffaceFin }

procedure Msg(S : WrkString);
begin
  EffaceFin(25);
  GotoXY(1, 25);
  Write(S);
  Delay(750);
end; { Msg }

procedure ChoisitIBM;
begin
  SelectWorld(2);
  SelectWindow(10);
end; { ChoisitIBM }

procedure DefinitFenIBM(I, X1, Y1, X2, Y2 : integer);
begin
  DefineWindow(I, Trunc(X1 / 79 * XMaxGlb + 0.001), Trunc(Y1 / 199 * YMaxGlb + 0.001),
		  Trunc(X2 / 79 * XMaxGlb + 0.5), Trunc(Y2 / 199 * YMaxGlb + 0.5));
end; { DefineWindow }

procedure DeplHorIBM(Delta : integer; Remplit : boolean);
var
  D : integer;
begin
  D := Trunc(abs(Delta) / 79 * XMaxGlb + 0.001);
  if Delta < 0 then
    D := -D;
  MoveHor(D, Remplit);
end; { DeplHorIBM }

procedure DeplVerIBM(Delta : integer; Remplit : boolean);
var
  D : integer;
begin
  D := Trunc(abs(Delta) / 199 * YMaxGlb + 0.001);
  if Delta < 0 then
    D := -D;
  MoveVer(D, Remplit);
end; { DeplVerIBM }

{----------------------------------------------------------------------------}

procedure Intro;
var
  I : integer;
begin
  SetHeaderOff;
  DefinitFenIBM(1, 5, 40, 25, 80);
  DefinitFenIBM(2, 16, 55, 43, 95);
  DefinitFenIBM(4, 15, 60, 43, 135);
  SelectWindow(1);
  DrawBorder;
  ChoisitIBM;
  DrawTextW(52, 144, 5, 'TURBO');
  StoreWindow(1);
  Delay(500);
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  ChoisitIBM;
  DrawTextW(140, 129, 5, 'GRAPHIX');
  StoreWindow(2);
  Delay(500);
  for I := 1 to 4 do
  begin
    RestoreWindow(1, 0, 0);
    Delay(800);
    RestoreWindow(2, 0, 0);
    Delay(800);
  end;
  for I := 1 to 8 do
  begin
    RestoreWindow(1, Trunc(3 * I * XMaxGlb / 79), Trunc(9 * I * YMaxGlb / 199));
    Delay(500);
    RestoreWindow(2, Trunc(3 * I * XMaxGlb / 79), Trunc(9 * I * YMaxGlb / 199));
    Delay(500);
  end;
  Delay(500);
  SelectWindow(4);
  StoreWindow(4);
  SetBackground(0);
  DrawBorder;
  GotoXY(16, 10);
  WriteLn('GRAPHIQUES pour TURBO PASCAL');
  for I := 2 to 40 do
  begin
    DrawLine(I * 8, 139, 639 - I * 8, 9);
    DrawLine(639 - I * 8, 139, I * 8, 9);
  end;
  Delay(2500);
  RestoreWindow(4, 0, 0);
  InvertScreen;
  SelectScreen(2);
  ClearScreen;
  InvertScreen;
  SetColorBlack;
  ChoisitIBM;
  DrawTextW(40, 124, 3, 'Par');
  DrawTextW(40, 59, 4, 'BORLAND INTERNATIONAL');
  CopyScreen;
  SelectScreen(1);
  Delay(5000);
  DefinitFenIBM(1, 1, 125, 35, 168);
  StoreWindow(1);
  DefinitFenIBM(2, 36, 125, 78, 168);
  StoreWindow(2);
  for I := 1 to Trunc(34 * XMaxGlb / 79) do
  begin
    SelectWindow(1);
    MoveHor(1, false);
    ReDefineWindow(1, X1RefGlb, Y1RefGlb, X2RefGlb - 1, Y2RefGlb);
    SelectWindow(2);
    MoveHor(-1, false);
    ReDefineWindow(2, X1RefGlb + 1, Y1RefGlb, X2RefGlb, Y2RefGlb);
  end;
  SetColorWhite;
  DrawTextW(X1RefGlb - 56, Y1RefGlb + 96, 4, '_');
  SetColorBlack;
  Delay(1000);
  RestoreWindow(1, 0, 0);
  RestoreWindow(2, 0, 0);
  GotoXY(1, 25);
  ClrEOL;
  GotoXY(17, 25);
  Write('Copyright (C) 1985 Borland International, Inc.');
  Delay(3000);
  SetColorWhite;
  SetHeaderOn;
End; { Intro }

{----------------------------------------------------------------------------}

procedure Simple;
var
  I, J, Rnd : integer;
  Rad : Float;
  Ch : char;

procedure TracePoints;
var
  I : integer;
begin
  SetBackground(0);
  DrawBorder;
  for I := 1 to 250 do
    DrawPoint(Random(640), Random(200));
end; { TracePoints }

procedure TraceLignes;
var
  I : integer;
begin
  SetBackground(0);
  DrawBorder;
  for I := 1 to 20 do
    DrawLine(I * 31, 199, 640 - I * 31, 199 - I * 10);
end; { TraceLignes }

procedure TraceCarres;
var
  I : integer;
begin
  SetBackground(0);
  DrawBorder;
  for I := 1 to 15 do
    DrawSquare(320 - I * 20, 100 - I * 6, 320 + I * 20, 100 + I * 6, false);
end; { TraceCarres }

procedure TraceCercles;
var
  I : integer;
  PosAspect : Float;
begin
  SetBackground(0);
  DrawBorder;
  Rad := 0.8;
  PosAspect := GetAspect;
  SetAspect(1 / 4.5);
  for I := 1 to 15 do
  begin
    DrawCircle(320, 100, Rad);
    SetAspect((1 + I) / 4.5);
    Rad := Rad - 0.05;
  end;
  SetAspect(PosAspect);
end; { TraceCercles }

procedure TraceSectoriel1;
var
  A : PieArray;
  I : integer;
begin
  SetBackground(0);
  DrawBorder;
  for I := 1 to 5 do
  begin
    A[I].Zone := Random + 0.35;
    A[I].Text := '';
  end;
  A[2].Zone := -A[2].Zone;
  DrawCartPie(320, 100, 500, 100, 1, 1, A, 5, 0, 1);
end; { TraceSectoriel1 }

procedure Hachure;
var
  I, Temp, X1, X2, Y1, Y2 : integer;
begin
  SetBackground(0);
  DrawBorder;
  for I := 1 to 5 do
  begin
    X1 := 100 + Random(500);
    X2 := 100 + Random(500);
    Y1 := 30 + Random(160);
    Y2 := 30 + Random(160);
    if X1 > X2 then
    begin
      Temp := X1;
      X1 := X2;
      X2 := Temp;
    end;
    if Y1 < Y2 then
    begin
      Temp := Y1;
      Y1 := Y2;
      Y2 := Temp;
    end;
    DrawSquare(X1, Y1, X2, Y2, false);
    Hatch(X1, Y1, X2, Y2, Random(6) + 5);
  end;
end; { Hachure }

begin { Simple }
  ClearScreen;
  SetHeaderOn;
  DefinitFenIBM(1, 0, 0, 79, 185);
  DefineHeader(1, 'Procedures graphiques simples ');
  SelectWindow(1);
  SetBackground(90);
  DrawBorder;
  CopyScreen;
  DefinitFenIBM(2, 28, 60, 49, 140);
  SelectWindow(2);
  Msg(' Dessin des points  :  DrawPoint');
  TracePoints;
  DeplVerIBM(-44, true);
  DeplHorIBM(-26, true);
  Delay(1000);
  DefinitFenIBM(3, 28, 60, 49, 140);
  SelectWindow(3);
  Msg(' Dessin des lignes  :  DrawLine');
  TraceLignes;
  DeplVerIBM(-44, true);
  CopyScreen;
  Delay(1000);
  DefinitFenIBM(4, 28, 60, 49, 140);
  SelectWindow(4);
  Msg(' Dessin des carrs  :  DrawSquare');
  TraceCarres;
  DeplVerIBM(-44, true);
  DeplHorIBM(26, true);
  Delay(1000);
  DefinitFenIBM(5, 28, 60, 49, 140);
  SelectWindow(5);
  Msg(' Dessin des cercles  :  DrawCircle');
  TraceCercles;
  DeplVerIBM(40, true);
  DeplHorIBM(26, true);
  Delay(1000);
  DefinitFenIBM(6, 28, 60, 49, 140);
  SelectWindow(6);
  Msg('Dessin des segments de cercle : DrawCircleSegment');
  TraceSectoriel1;
  DeplVerIBM(40, true);
  CopyScreen;
  Delay(1000);
  DefinitFenIBM(7, 28, 60, 49, 140);
  SelectWindow(7);
  Msg('  Carrs hachurs   :   Hatch');
  Hachure;
  DeplVerIBM(40, true);
  DeplHorIBM(-26, true);
  Delay(1000);
  EffaceFin(25);
  for I := 1 to 5 do
  begin
    SelectWindow(2);
    InvertWindow;
    for J := 3 to 7 do
    begin
      SelectWindow(J);
      InvertWindow;
      SelectWindow(J - 1);
      InvertWindow;
    end;
    SelectWindow(7);
    InvertWindow;
  end;
  Msg('              Pressez RETURN pour continuer');
  for I := 2 to 7 do
  begin
    SelectWindow(I);
    InvertWindow;
  end;
  I := 0;
  Ch := ' ';
  repeat
    Rnd := Random(6) + 1;
    SelectWindow(Rnd + 1);
    case Rnd of
      1 : TracePoints;
      2 : TraceLignes;
      3 : TraceCarres;
      4 : TraceCercles;
      5 : TraceSectoriel1;
      6 : Hachure;
    end;
    InvertWindow;
    I := I + 1;
    if KeyPressed then
      Ch := ReadKey;
  until (Ch = ^M) or (I = 30);
end; { Simple }

{----------------------------------------------------------------------------}

procedure DemoFenetre;
var
  Rangee, Colonne, I : integer;

procedure EcritLent(S : WrkString);
var
  I : integer;
begin
  Rangee := Rangee + 1;
  GotoXY(17, 5);
  Write(Rangee:2);
  GotoXY(8, 6 + Rangee);
  for I := 1 to Length(S) do
  begin
    Write(S[I]);
    GotoXY(28, 5);
    Write(Colonne + I:2);
    GotoXY(8 + I, 6 + Rangee);
    Delay(10 + Random(100));
  end;
end; { EcritLent }

begin { DemoFenetre }
  ClearScreen;
  SetHeaderOn;
  DefinitFenIBM(1, 0, 0, 79, 190);
  DefineHeader(1, 'Utilisation de plusieurs fenetres sur un ecran');
  SelectWindow(1);
  SetBackground(24);
  DrawBorder;
  DefinitFenIBM(2, 4, 16, 55, 140);
  DefineHeader(2, 'Exemple :  Edition');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  Colonne := 0; Rangee := 0;
  GotoXY(11, 5); Write('Ligne    Colonne    Fichier A:TEST.TXT');
  GotoXY(8, 6);  Write('G----#----#----#----#----#----#----#----#----D');
  GotoXY(8, 7); EcritLent ('Voici une dmonstration de l''utilisation ');
  GotoXY(8, 8); EcritLent ('des fentres avec le systme TURBO GRAPHIX.');
  GotoXY(8, 9); EcritLent ('Une fentre est une partie dfinie de l''cran.');
  GotoXY(8, 10); EcritLent('Toutes les commandes graphiques se rfrent aux');
  GotoXY(8, 11); EcritLent('fentres. Les parties du diagramme se situant ');
  GotoXY(8, 12); EcritLent('hors de la fentre ne sont pas dessines. ');
  GotoXY(8, 13); EcritLent('L''chelle est aussi gre par TURBO GRAPHIX,');
  GotoXY(8, 14); EcritLent('permettant de dessiner en coordonnes absolues.');
  GotoXY(19, 16);
  StoreWindow(2);
  AttendReturn(60000.0);
  DefinitFenIBM(3, 25, 30, 78, 180);
  DefineHeader(3, 'Exemple :  Diagrammes');
  SelectWindow(3);
  SetBackground(0);
  DrawBorder;
  GotoXY(28, 7);
  Write('        1        2        3        4        5');
  for I := 1 to 12 do
  begin
    GotoXY(28, 7 + I);
    Write(I:2);
  end;
  GotoXY(28, 20); Write('Commande? _________________________________________');
  GotoXY(28, 22); Write('Fichier : ventes.clc      libre : 85 kByte = 92.3 %');
  GotoXY(40, 9); Write(' MAQUETTE  DES  VENTES  1987');
  GotoXY(40, 10); Write(' ===============================');
  GotoXY(32, 12); Write('Cots de production  :   1456.35');
  GotoXY(32, 13); Write('Cots de personnel   :    145.23');
  GotoXY(32, 14); Write('Taxes                :    524.12');
  GotoXY(32, 15); Write('--------------------------------');
  GotoXY(32, 16); Write('Sous-total           :   2125.70');
  GotoXY(32, 18); Write('Solde                :       145');
  Delay(4000);
  GotoXY(39, 20);
  AttendReturn(15000);
  DefinitFenIBM(4, 12, 60, 68, 164);
  DefineHeader(4, 'Exemple:  Graphiques');
  SelectWindow(4);
  SetBackground(0);
  DrawBorder;
  for I := 1 to 85 do
    DrawLine(20 + I * 7, 30, 630 - I * 7, 170);
  GotoXY(29, 20);
  CopyScreen;
  AttendReturn(15000);
  RestoreWindow(2, Trunc(16 * XMaxGlb / 79), Trunc(32 * YMaxGlb / 199));
  SelectWindow(2);
  Delay(2000);
  DeplHorIBM(-16, true);
  DeplVerIBM(-32, true);
  for I := 1 to 11 do
  begin
    GotoXY(8, 6 + I);
    Write('                                                ');
  end;
  Rangee := 0;
  Colonne := 0;
  GotoXY(8, 7); EcritLent('Vous pouvez aussi dplacer votre fentre sur');
  GotoXY(8, 8); EcritLent('l''cran. Les fentres peuvent glisser les');
  GotoXY(8, 9); EcritLent('unes sur les autres et s''empiler. Une fentre');
  GotoXY(8, 10); EcritLent('peut aussi tre place dans une mmoire');
  GotoXY(8, 11); EcritLent('fentre et, ainsi, tre rappele si le');
  GotoXY(8, 12); EcritLent('besoin s''en fait sentir. La taille de');
  GotoXY(8, 13); EcritLent('la mmoire fentre n''est limite que par');
  GotoXY(8, 14); EcritLent('la taille de la mmoire centrale.');
  GotoXY(19, 16);
  AttendReturn(60000.0);
end; { DemoFenetre }

{----------------------------------------------------------------------------}
procedure Sier;
const
  N = 4;
var
  I, H, X, Y, X0, Y0 : integer;
  Sec : boolean;

procedure Allume;
begin
  if Sec then
    SetColorWhite
  else
    SetColorBlack;
  DrawLine(X, Y, X0, Y0);
  DrawLine(X + 256, Y + 256, X0 + 256, Y0 + 256);
  if Sec then
    SetColorBlack
  else
    SetColorWhite;
  DrawLine(X + 256, Y, X0 + 256, Y0);
  DrawLine(X, Y + 256, X0, Y0 + 256);
  X0 := X;
  Y0 := Y;
end; { Allume }

procedure B(I:integer); forward;

procedure C(I:integer); forward;

procedure D(I:integer); forward;

procedure A(I:integer);
begin
  if I > 0 then
  begin
    A(I - 1);
    X := X + H;
    Y := Y - H;
    Allume;
    B(I - 1);
    X := X + 2 * H;
    Allume;
    D(I - 1);
    X := X + H;
    Y := Y + H;
    Allume;
    A(I - 1);
  end;
end; { A }

procedure B;
begin
  if I > 0 then
  begin
    B(I - 1);
    X := X - H;
    Y := Y - H;
    Allume;
    C(I - 1);
    Y := Y - 2 * H;
    Allume;
    A(I - 1);
    X := X + H;
    Y := Y - H;
    Allume;
    B(I - 1);
  end;
end; { B }

procedure C;
begin
  if I > 0 then
  begin
    C(I - 1);
    X := X - H;
    Y := Y + H;
    Allume;
    D(I - 1);
    X := X - 2 * H;
    Allume;
    B(I - 1);
    X := X - H;
    Y := Y - H;
    Allume;
    C(I - 1);
  end;
end; { C }

procedure D;
begin
  if I > 0 then
  begin
    D(I - 1);
    X := X + H;
    Y := Y + H;
    Allume;
    A(I - 1);
    Y := Y + 2 * H;
    Allume;
    C(I - 1);
    X := X - H;
    Y := Y + H;
    Allume;
    D(I - 1);
  end;
end; { D }

procedure Fais;
begin
  I := 3;
  H := 16;
  X0 := 30;
  Y0 := 240;
  repeat
    I := I + 1;
    X0 := X0 - H;
    H := H div 2;
    Y0 := Y0 + H;
    X := X0;
    Y := Y0;
    A(I - 1);
    X := X + H;
    Y := Y - H;
    Allume;
    B(I - 1);
    X := X - H;
    Y := Y - H;
    Allume;
    C(I - 1);
    X := X - H;
    Y := Y + H;
    Allume;
    D(I - 1);
    X := X + H;
    Y := Y + H;
    Allume;
  until I = N;
end; { Fais }

begin  { Sier }
  SetHeaderOn;
  DefineWorld(1, -3, -3, 514, 514);
  SelectWorld(1);
  DefinitFenIBM(2, 0, 0, 39, 99);
  SelectWindow(2);
  InvertWindow;
  DefinitFenIBM(2, 40, 100, 79, 190);
  SelectWindow(2);
  InvertWindow;
  DefinitFenIBM(1, 0, 0, 79, 190);
  DefineHeader(1, 'Courbe Sierpinski');
  SelectWindow(1);
  DrawBorder;
  GotoXY(1, 25);
  Write('  La fentre est constitue par l''cran entier');
  Sec := false;
  Fais;
  GotoXY(52, 25);
  AttendReturn(15000);
  DefinitFenIBM(1, 20, 40, 59, 159);
  SelectWindow(1);
  SetBackground(0);
  DrawBorder;
  DefinitFenIBM(2, 40, 40, 59, 99);
  SelectWindow(2);
  InvertWindow;
  DefinitFenIBM(2, 20, 100, 39, 159);
  SelectWindow(2);
  InvertWindow;
  SelectWindow(1);
  EffaceFin(25);
  GotoXY(1, 25);
  Write('  Dessin identique dans des fentres plus petites');
  Sec := true;
  Fais;
  GotoXY(52, 25);
  AttendReturn(15000);
  EffaceFin(25);
  GotoXY(1, 25);
  Write('  L''cran est sauv avec la procdure SaveScreen, ...');
  SaveScreen('TEST.PIC');
  Delay(1000);
  ClearScreen;
  Delay(1000);
  LoadScreen('TEST.PIC');
  EffaceFin(25);
  GotoXY(1, 25);
  Write('     ... et raffich ensuite.');
  GotoXY(52, 25);
  AttendReturn(15000);
  DefineWorld(1, 0, 0, 639, 199);
  SelectWorld(1);
  SelectWindow(1);
  SetColorWhite;
end; { Sier }

{----------------------------------------------------------------------------}

procedure DemSectoriel;
var
  Somme : Float;
  I, J, N : integer;
  A : PieArray;

begin
  ClearScreen;
  SetColorWhite;
  DefinitFenIBM(1, 0, 0, 79, 185);
  DefinitFenIBM(2, 20, 20, 77, 180);
  DefinitFenIBM(3, 28, 60, 59, 150);
  DefinitFenIBM(4, 28, 60, 59, 140);
  DefinitFenIBM(5, 28, 60, 59, 140);
  DefinitFenIBM(6, 28, 60, 59, 140);
  DefineHeader(1, 'Les applications avec camembert');
  DefineHeader(2, 'Volume des ventes');
  DefineHeader(3, 'Avec texte');
  DefineHeader(4, 'Avec texte');
  DefineHeader(5, 'Avec texte et nombres');
  DefineHeader(6, 'Sans texte');
  A[1].Zone := 25;
  A[1].Text := 'JAN. ';
  A[2].Zone := 17.5;
  A[2].Text := 'FEV. ';
  A[3].Zone := 9.6;
  A[3].Text := 'MAR. ';
  A[4].Zone := 21;
  A[4].Text := 'AVR. ';
  A[5].Zone := 35;
  A[5].Text := 'MAI  ';
  N := 5;
  Somme := 0;
  for I := 1 to N do
  begin
    A[I].Zone := A[I].Zone + 5.35;
    Somme := Somme + A[I].Zone;
  end;
  SelectWindow(1);
  DrawBorder;
  GotoXY(24, 5);
  WriteLn('Ventes 1985');
  GotoXY(5, 8);
  Write('Sommes en F (X 1,000,000)');
  GotoXY(40, 8);
  Write('Sommes en pourcentages');
  for I := 1 to N do
  begin
    GotoXY(11, 9 + I);
    WriteLn(A[I].Text, '  ', A[I].Zone:3:2, '                            ',
	    A[I].Zone / Somme * 100:3:2);
  end;
  Msg('  Dessin du second cran sur le fond  :  SelectScreen');
  SelectScreen(2);
  ClearScreen;
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  A[1].Zone := -A[1].Zone;
  DrawCartPie(300, 100, 390, 73, 1.05, 1.5, A, N, 2, 2);
  ResetWindowStack;
  StoreWindow(2);
  SelectScreen(1);
  RestoreWindow(2, 0, 0);
  Delay(15000);
  CopyScreen;
  Msg('  Variations du diagramme sectoriel  :  DrawCartPie');
  SetColorBlack;
  SelectWindow(3);
  SetBackground(255);
  DrawBorder;
  A[4].Zone := -A[4].Zone;
  DrawCartPie(320, 100, 437, 73, 1.05, 1.6, A, N, 1, 1);
  A[4].Zone := -A[4].Zone;
  DeplVerIBM(-32, true);
  DeplHorIBM(-26, true);
  CopyScreen;
  Delay(1000);
  SelectWindow(4);
  SetBackground(255);
  DrawBorder;
  DrawCartPie(320, 100, 437, 73, 0.75, 1.5, A, N, 1, 1);
  DeplVerIBM(-44, true);
  DeplHorIBM(19, true);
  Delay(1000);
  CopyScreen;
  SelectWindow(5);
  SetBackground(255);
  DrawBorder;
  DrawCartPie(320, 100, 437, 100, 0.7, 1.4, A, N, 2, 1);
  DeplVerIBM(30, true);
  DeplHorIBM(-18, true);
  Delay(1000);
  SelectWindow(6);
  SetBackground(255);
  DrawBorder;
  DrawCartPie(320, 100, 482, 73, 1, 1.5, A, N, 0, 1);
  Delay(1000);
  Delay(15000);
  RestoreWindow(2, 0, 0);
  Delay(15000);
  SetColorWhite;
end; { DemSectoriel }

{----------------------------------------------------------------------------}

procedure DemSpline;
var
  X, Temp : Float;
  M, Dx, Dy, I, J, N, Lignes, Echelle : integer;
  X1, Y1, X2, Y2 : integer;
  B, A : PlotArray;
begin
  ClearScreen;
  SetColorWhite;
  GotoXY(48, 25);
  Write('veuillez attendre un instant ...');
  Dx := -8;
  Dy := 7;
  X1 := 3;
  Y1 := 5;
  X2 := 25;
  Y2 := 10;
  Lignes := 0;
  Echelle := 0;
  N := 12;
  M := 50;
  X := -49;
  DefinitFenIBM(1, 0, 0, 79, 185);
  DefinitFenIBM(2, 30, 20, 70, 164);
  DefineHeader(1, 'Interpolation Spline');
  DefineHeader(2, 'Variation du diagramme');
  X := -49;
  for I := 1 to N do
  begin
    A[I, 1] := I - 1;
    A[I, 2] := Random - 0.5;
    X := X + 7;
  end;
  Spline(A, N, A[2, 1], A[N - 1, 1], B, M);
  FindWorld(1, B, M, 1, 1.08);
  SelectWindow(1);
  EffaceFin(25);
  GotoXY(10, 25);
  Write('Donnes ');
  FindWorld(1, B, M, 1, 1.08);
  SelectWindow(1);
  DrawBorder;
  DrawAxis(Dx, Dy, X1, Y1, X2, Y2, Lignes, Echelle, false);
  SetLineStyle(1);
  DrawPolygon(A, 2, N - 1, 7, 2, 0);
  SetLineStyle(0);
  ChoisitIBM;
  DrawTextW(470, 129, 1, ^['7@2   Donnees ');
  DrawTextW(470, 109, 1, '--  Valeurs interpolees');
  GotoXY(50, 25);
  SelectWorld(1);
  SelectWindow(1);
  AttendReturn(15000);
  EffaceFin(25);
  GotoXY(10, 25);
  Write('La fonction d''interpolation Spline');
  ResetAxis;
  DrawPolygon(B, 1, -M, 0, 0, 0);
  CopyScreen;
  GotoXY(50, 25);
  AttendReturn(15000);
  EffaceFin(25);
  GotoXY(10, 25);
  Write('Echange des coordonnes verticales');
  with World[1] do     { Fait pivoter verticalement le monde trouv }
  begin
    Temp := Y1;
    Y1 := Y2;
    Y2 := Temp;
  end;
  SelectWorld(1);
  SelectWindow(2);
  SetBackground(255);
  SetColorBlack;
  DrawBorder;
  DrawAxis(abs(Dx), abs(Dy), 0, 0, 0, 0, 0, 0, false);
  DrawPolygon(A, 2, N - 1, -2, 2, -1);
  ResetAxis;
  DrawPolygon(B, 1, -M, 0, 0, 0);
  SetColorWhite;
  GotoXY(50, 25);
  AttendReturn(15000);
  EffaceFin(25);
  GotoXY(10, 25);
  Write('Dplacement de fentre');
  DeplVerIBM(-15, true);
  DeplHorIBM(-30, true);
  DeplVerIBM(35, true);
  DeplHorIBM(35, true);
  DeplVerIBM(-5, true);
  DeplHorIBM(-5, true);
  GotoXY(50, 25);
  AttendReturn(15000);
  EffaceFin(25);
  GotoXY(10, 25);
  Write('Inversion de fentre');
  InvertWindow;
  SetColorWhite;
  GotoXY(50, 25);
  AttendReturn(15000);
  SelectScreen(2);
  EffaceFin(25);
  GotoXY(10, 25);
  Write('Reconstruction de la premire figure');
  CopyScreen;
  SelectScreen(1);
  GotoXY(50, 25);
  AttendReturn(15000);
end; { DemSpline }

{----------------------------------------------------------------------------}

procedure DemGraphe;
var
  N : integer;
  B, A : PlotArray;
  X1, X2 : integer;

procedure GenereFonction(var A, B : PlotArray; N : integer);
var
  I : integer;
  Delta : Float;
begin
  Delta := 2 * Pi / (N - 1);
  for I := 1 to N do
  begin
    A[I, 1] := (I - 1) * Delta - Pi;
    B[I, 1] := A[I, 1];
    B[I, 2] := Exp(-abs(A[I, 1]));
    A[I, 2] := Sin(A[I, 1]) * Exp(-abs(A[I, 1]) * 0.1);
  end;
end; { GenereFonction }

begin { DemGraphe }
  ClearScreen;
  SetColorWhite;
  N := 30;
  GotoXY(48, 25);
  Write('Veuillez attendre un instant ....');
  GenereFonction(A, B, N);
  ClearScreen;
  DefineWorld(1, -Pi, 1, Pi, -1);
  SelectWorld(1);
  Msg('Fonction exemple en coordonnes relatives  [-Pi,Pi] : DrawPolygon');
  DefinitFenIBM(1, 0, 0, 39, 95);
  DefineHeader(1, 'Fonction exemple');
  SelectWindow(1);
  DrawBorder;
  DrawPolygon(A, 1, N, 0, 0, 0);
  Delay(15000);
  Msg('Procdures utilises : DrawAxis , DrawPolygon');
  DefinitFenIBM(2, 20, 40, 79, 185);
  DefineHeader(2, 'Fonction exemple avec axes');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(8, -8, 0, 0, 0, 0, 0, 0, false);
  DrawPolygon(A, 1, N, 0, 0, 0);
  Delay(15000);
  Msg('Densit plus forte des axes : DrawAxis , DrawPolygon');
  DefinitFenIBM(2, 8, 15, 70, 170);
  DefineHeader(2, 'Fonction exemple avec axes');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(9, -9, 0, 0, 0, 0, 1, 1, false);
  DrawPolygon(A, 1, N, 0, 0, 0);
  Delay(15000);
  Msg('Fonction exemple affiche par points : DrawPolygon');
  DefinitFenIBM(1, 0, 0, 39, 95);
  DefineHeader(1, 'Fonction exemple');
  SelectWindow(1);
  SetBackground(0);
  DrawBorder;
  DrawPolygon(A, 1, N, 9, 1, 0);
  Delay(15000);
  Msg('Fonction exemple affiche par cercles : DrawPolygon');
  DrawPolygon(A, 1, N, -8, 3, 0);
  Delay(15000);
  Msg('Fonction exemple relie par des lignes : SetLinestyle , DrawPolygon');
  SetLinestyle(1);
  DrawPolygon(A, 1, N, 0, 0, 0);
  SetLinestyle(0);
  Delay(15000);
  Msg('Affichage de plusieurs fonctions par appels rpts  DrawPolygon');
  DefinitFenIBM(2, 20, 40, 79, 185);
  DefineHeader(2, 'Deux fonctions affichees avec les axes');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(8, -8, 0, 0, 0, 0, 0, 0, false);
  DrawPolygon(A, 1, N, -1, 4, 0);
  Delay(15000);
  Msg('Les points de la premire fonction sont relis par des lignes : DrawPolygon');
  DrawAxis(0, 0, 0, 0, 0, 0, 0, 0, false);
  DrawPolygon(A, 1, N, 0, 0, 0);
  Delay(15000);
  Msg('La deuxime fonction dans le mme systme de coordonnes');
  DrawAxis(0, 0, 0, 0, 0, 0, 0, 0, false);
  DrawPolygon(B, 1, N, -4, 2, 0);
  Delay(15000);
  Msg('Les points de la deuxime fonction sont relis par des lignes : DrawPolygon');
  DrawAxis(0, 0, 0, 0, 0, 0, 0, 0, false);
  SetLinestyle(1);
  DrawPolygon(B, 1, N, 0, 0, 0);
  SetLinestyle(0);
  Delay(15000);
  Msg('Graduation des axes  plus forte densit : DrawAxis , DrawPolygon');
  DefinitFenIBM(2, 8, 15, 70, 170);
  DefineHeader(2, 'Graduation');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawAxis(8, -8, 0, 0, 0, 0, 0, 1, false);
  DrawPolygon(A, 1, N, -2, 3, 0);
  Delay(15000);
  DrawAxis(0, 0, 0, 0, 0, 0, -1, -1, false);
  DrawPolygon(A, 1, N, 9, 1, -1);
  Delay(15000);
  DrawAxis(0, 0, 0, 0, 0, 0, -1, -1, false);
  SetLinestyle(2);
  DrawPolygon(A, 1, N, 0, 0, 0);
  SetLinestyle(0);
  Delay(15000);
end; { DemGraphe }

{----------------------------------------------------------------------------}

procedure DemHisto;
var
  I, N : integer;
  A : PlotArray;
  R, Temp : Float;

begin
  GotoXY(48, 25);
  Write('Veuillez attendre un instant ...');
  N := 50;
  R := abs(N / 2);
  for I := 0 to abs(N - 1) do
  begin
    A[I + 1, 1] := I - R;
    A[I + 1, 2] := Sin(A[I + 1, 1] / 10) *
		   Exp(-abs(A[I + 1, 1]) * 0.01) + Random * 0.1;
  end;
  ClearScreen;
  SetColorWhite;
  DefinitFenIBM(1, 0, 0, 79, 185);
  DefinitFenIBM(2, 20, 20, 75, 175);
  DefinitFenIBM(3, 5, 35, 60, 170);
  DefinitFenIBM(4, 10, 50, 55, 165);
  DefineHeader(1, 'Histogramme en valeur absolue');
  DefineHeader(2, 'Histogramme en mode normal');
  DefineHeader(3, 'Histogramme en mode normal avec hachures');
  DefineHeader(4, 'Histogramme avec axes');
  Msg('Affichage des valeurs : DrawHistogram');
  FindWorld(1, A, N, 1.1, 1.1);
  SelectWorld(1);
  SelectWindow(1);
  DrawBorder;
  DrawHistogram(A, N, false, 5);
  Delay(15000);
  Msg('Affichage des valeurs positives et ngatives : DrawHistogram');
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  DrawHistogram(A, -N, false, 5);
  Delay(15000);
  Msg('La densit du hachurage peut se modifier : DrawHistogram');
  SelectWindow(3);
  SetBackground(0);
  DrawBorder;
  DrawHistogram(A, -N, true, 4);
  Delay(15000);
  Msg('La densit des axes est modifiable : DrawAxis , DrawHistogram');
  SelectWindow(4);
  SetBackground(0);
  DrawBorder;
  DrawAxis(7, -7, 0, 0, 0, 0, 0, 0, true);
  DrawHistogram(A, -N, true, 2);
  Delay(15000);
end; { DemHisto }

{----------------------------------------------------------------------------}

procedure DemOrganigramme;
var
  X1, Y1, X2, Y2, I, Compte : integer;

procedure TraceFlecheHor(X1, Y1, X2, Y2 : integer);
begin
  DrawLine(X1, Y1, X2, Y2);
  if X2 > X1 then
    begin
      DrawLine(X2 - 4, Y2 - 2, X2, Y2);
      DrawLine(X2 - 4, Y2 + 2, X2, Y2);
    end
  else
    begin
      DrawLine(X2 + 5, Y2 - 2, X2, Y2);
      DrawLine(X2 + 5, Y2 + 2, X2, Y2);
    end;
end; { TraceFlecheHor }

procedure TraceFlecheVer(X1, Y1, X2, Y2 : integer);
begin
  DrawLine(X1, Y1, X2, Y2);
  if Y2 > Y1 then
    begin
      DrawLine(X2 - 2, Y2 - 3, X2, Y2);
      DrawLine(X2 + 2, Y2 - 3, X2, Y2);
    end
  else
    begin
      DrawLine(X2 - 2, Y2 + 3, X2, Y2);
      DrawLine(X2 + 2, Y2 + 3, X2, Y2);
    end;
end; { TraceFlecheVer }

procedure Clignote(Compte, Temps : integer);
var
  I : integer;
begin
  for I := 1 to Compte do
  begin
    Delay(Temps);
    InvertWindow;
  end;
end; { Clignote }

begin { DemOrganigramme }
  DefinitFenIBM(1, 0, 0, 79, 185);
  DefinitFenIBM(2, 12, 20, 25, 40);
  DefinitFenIBM(3, 15, 55, 22, 75);
  DefinitFenIBM(4, 11, 110, 26, 130);
  DefinitFenIBM(5, 47, 90, 56, 110);
  DefineHeader(1, 'Un organigramme');
  SetColorWhite;
  SetHeaderOn;
  SelectWindow(1);
  DrawBorder;
  SetHeaderOff;
  SelectWindow(2);
  DrawBorder;
  ChoisitIBM;
  DrawTextW(125, 172, 2, 'Debut');
  TraceFlecheVer(151, 159, 151, 144);
  SelectWindow(3);
  DrawBorder;
  ChoisitIBM;
  DrawTextW(136, 136, 2, 'I=1');
  TraceFlecheVer(151, 124, 151, 89);
  SelectWindow(4);
  DrawBorder;
  ChoisitIBM;
  DrawTextW(108, 81, 2, 'si I<=5');
  DrawLine(215, 79, 417, 79);
  TraceFlecheVer(417, 79, 417, 89);
  TraceFlecheVer(151, 69, 151, 44);
  ChoisitIBM;
  DrawTextW(300, 89, 2, 'OUI');
  DrawTextW(160, 62, 2, 'NON');
  SelectWindow(5);
  DrawBorder;
  ChoisitIBM;
  DrawTextW(390, 101, 2, 'I=I+1');
  DrawLine(417, 119, 417, 109);
  TraceFlecheHor(417, 119, 151, 119);
  DrawCircle(151, 34, 0.25);
  DrawTextW(137, 36, 2, 'fin');
  SetHeaderOn;
  CopyScreen;
  EffaceFin(25);
  GotoXY(27, 25);
  DefinitFenIBM(2, 15, 21, 22, 39);
  SelectWindow(2);
  SetBackground(0);
  DrawBorder;
  InvertWindow;
  Delay(1000);
  InvertWindow;
  DeplVerIBM(35, true);
  ChoisitIBM;
  DrawTextW(139, 136, 2, 'I=1');
  SelectWindow(2);
  Clignote(30, 50);
  DeplVerIBM(55, true);
  for Compte := 2 to 6 do
  begin
    Delay(500);
    DeplHorIBM(33, true);
    DeplVerIBM(-20, true);
    SetBackground(0);
    DrawBorder;
    ChoisitIBM;
    DrawTextW(400, 101, 2, 'I=' + Chr(48 + Compte));
    SelectWindow(2);
    Clignote(30, 50);
    DeplVerIBM(-20, true);
    DeplHorIBM(-33, true);
    DeplVerIBM(40, true);
  end;
  InvertWindow;
  Delay(1000);
  DeplVerIBM(46, true);
  Clignote(30, 50);
  DeplHorIBM(45, true);
  DeplVerIBM(-136, true);
  DeplHorIBM(-45, true);
  SetHeaderOn;
end; { DemOrganigramme }

{----------------------------------------------------------------------------}

procedure DemBezier;

procedure EffaceJusqueFin;
{ Procdure d'effacement de la fin de la ligne }
var
  I : integer;
begin
  for I := 1 to 80 do
    Write(' ');
end; { EffaceJusqueFin }

procedure DemandeLit(var S : WrkString);
const
  Cr = #13;
  Bs = #8;
var
  Compte : integer;
  Ch	: char;
begin
  Compte := 0;
  S := '';
  repeat
    Ch := ReadKey;
    case Ch of
      Bs : begin
	     if Compte > 0 then
	     begin
	       Write(Ch);
	       ClrEol;
	       Delete(S, Length(S), 1);
	       Dec(Compte);
	     end;
	   end;
    else
      if Ch <> Cr then
      begin
	Write(Ch);
	S := S + Ch;
	Compte := Compte + 1;
      end;
    end;
  until Ch = Cr;
end; { DemandeLit }

procedure DemoBezi;

var
  Resultat, I, PointsDeControleMaxi, PointsIntMaxi : integer;
  XFactice, YFactice : Float;
  A, B : PlotArray;
  Break : boolean;
  SFactice, Temp2, Temp : WrkString;

begin
  PointsDeControleMaxi := 7;		   { Initialise tout }
  PointsIntMaxi := 15;

  A[1, 1] := 1;   A[2, 1] := 1.5; A[3, 1] := 2;   A[4, 1] := 2.5;
  A[5, 1] := 3;   A[6, 1] := 4;   A[7, 1] := 5;   A[1, 2] := 2;
  A[2, 2] := 1.5; A[3, 2] := 1;   A[4, 2] := 2.5; A[5, 2] := 4;
  A[6, 2] := 4.5; A[7, 2] := 5;

  ClearScreen;			       { Prpare l'cran }
  SetColorWhite;
  DefineWorld(1, 0, 0, 6.33, 7.0);     { Ajuste le monde aux coordonnes }
  SelectWorld(1);
  DefineWindow(1, 0, 0, XMaxGlb, 17 * YMaxGlb div 20);
  SelectWindow(1);
  SetBackground(0);
  DefineHeader(1, 'Demonstration de conception de graphisme');
  DrawBorder;
  DrawAxis(7, -7, 0, 0, 0, 0, -1, -1, false);

  Break := false;		       { Initialise drapeau de sortie }

  repeat
    SetLinestyle(1);		       { Dessine un polygone
					 entre les points }
    ResetAxis;
    DrawPolygon(A, 1, PointsDeControleMaxi, 4, 2, 0);

    Bezier(A, PointsDeControleMaxi, B, PointsIntMaxi);	{ Excute l'opration
						     bezier }

    SetLinestyle(0);		       { Affiche }
    ResetAxis;
    DrawPolygon(B, 1, PointsIntMaxi, 0, 0, 0);

    repeat
      GotoXY(1, 24);		       { Efface l'ancien texte }
      EffaceJusqueFin;
      GotoXY(1, 25);
      EffaceJusqueFin;
      GotoXY(1, 23);
      EffaceJusqueFin;
      GotoXY(1, 23);		       { Lit point  modifier }
      Write('Numro du point  modifier (0 pour quitter) :  ');
      GotoXY(51, 23);
      DemandeLit(Temp);
      Val(Temp, I, Resultat);
    until I in [0..PointsDeControleMaxi];

    if I > 0 then
      begin
	repeat
	  GotoXY(1, 24);	       { Lit nouvelles valeurs de x et y }
	  Write('Ancienne position : [', A[I,1]:4:2, ',', A[I,2]:4:2, ']');
	  GotoXY(40, 24);
	  Write('   Nouvelle position  x:  ');
	  GotoXY(65, 24);
	  DemandeLit(SFactice);
	  while SFactice[1] = ' ' do
	    Delete(SFactice, 1, 1);
	  Temp := SFactice;
	  GotoXY(40, 25);
	  Write('   Nouvelle position  y:  ');
	  GotoXY(65, 25);
	  DemandeLit(SFactice);
	  while SFactice[1] = ' ' do
	    Delete(SFactice, 1, 1);
	  Temp2 := SFactice;
	  Val(Temp, XFactice, Resultat);
	  Val(Temp2, YFactice, Resultat);
	until ((XFactice >= X1WldGlb) and (XFactice <= X2WldGlb)) and
	      ((YFactice >= Y1WldGlb) and (YFactice <= Y2WldGlb));

	SetLinestyle(1);	       { Efface ancienne courbe }
	SetColorBlack;
	ResetAxis;
	DrawPolygon(A, 1, PointsDeControleMaxi, 4, 2, 0);
	SetLinestyle(0);
	ResetAxis;
	DrawPolygon(B, 1, PointsIntMaxi, 0, 0, 0);
	A[I, 1] := XFactice;
	A[I, 2] := YFactice;
	SetColorWhite;
      end
    else
      Break := true;
  until Break;
end; { DemoBezi }

begin
  DemoBezi;
end; { DemBezier }

{----------------------------------------------------------------------------}

function ChoixMenu(AncienChoix : integer) : integer;
const
  Nul	 = #0;
  Cr	  = #13;
  Bs	  = #8;
  CtrlC   = #3;
  Esc	  = #27;
  Prompt : string[6] = '==>   ';
  Titre = 'Dmonstration TOOLBOX TURBO GRAPHIX';
  N = 9;
  ElementsMenu : array [0..9] of string[35] = ('Fin de la dmonstration',
					    'Utilisation des fentres',
					    'Les commandes graphiques simples',
					    'Application:Les courbes sierpinski',
					    'Diagrammes sectoriels',
					    'Spline',
					    'Prsentation polygonale',
					    'Histogrammes',
					    'Application: Organigramme',
					    'Dessin et conception');

var
  X, Y, I : integer;
  J : word;
  Ch : char;
  Quitte : boolean;

begin
  AncienChoix := AncienChoix + 1;
  if AncienChoix > N - 1 then
     AncienChoix := 1;
  X := 40 - Length(Titre) div 2;
  GotoXY(X, 1);
  Write(Titre);
  GotoXY(1, 24);
  Write('Faites votre choix avec ESPACE / BACKSPACE ou un chiffre, puis frappez RETURN');
  Y := 8 - N div 2;
  X := 20;
  for I := 0 to N do
  begin
    GotoXY(X - 4, Y + I * 2);
    Write(I:1, ' -- ', ElementsMenu[I]);
  end;
  I := AncienChoix;
  GotoXY(X - 10, Y + I * 2);
  Write(Prompt, I:1, ' -- ', ElementsMenu[I]);
  GotoXY(62, Y + I * 2);
  Write('<==');

  J := 0;
  Ch := '#';
  Quitte := FALSE;
  while (Ch <> Cr) do
  begin
    Ch := '#';

    if KeyPressed then
    begin		  { Lit au clavier ! }
      Ch := ReadKey;
      J := 0;
    end;

    case Ch of
      Bs	 : begin
		     GotoXY(X - 10, Y + I * 2);
		     Write('      ');
		     GotoXY(62, Y + I * 2);
		     Write('   ');
		     I := I - 1;
		     if I = -1 then
		       I := N;
		     GotoXY(X - 10, Y + I * 2);
		     Write(Prompt, I:1, ' -- ', ElementsMenu[I]);
		     GotoXY(62, Y + I * 2);
		     Write('<==');
		   end;

      ' '	 : begin
		     GotoXY(X - 10, Y + I * 2);
		     Write('      ');
		     GotoXY(62, Y + I * 2);
		     Write('   ');
		     I := I + 1;
		     if I > N then
		       I := 0;
		     GotoXY(X - 10, Y + I * 2);
		     Write(Prompt, I:1, ' -- ', ElementsMenu[I]);
		     GotoXY(62, Y + I * 2);
		     Write('<==');
		   end;

      '0'..'9'	 : begin
		     if (Ord(Ch) - 48) <> I then
		     begin
		       GotoXY(X - 10, Y + I * 2);
		       Write('      ');
		       GotoXY(62, Y + I * 2);
		       Write('   ');
		       I := Ord(Ch) - 48;
		       GotoXY(X - 10, Y + I * 2);
		       Write(Prompt, I:1, ' -- ', ElementsMenu[I]);
		       GotoXY(62, Y + I * 2);
		       Write('<==');
		     end;
		   end;

      Esc, CtrlC : begin
		     LeaveGraphic;
		     Halt;
		   end;

      Nul	: begin
		     if KeyPressed then
		     begin
		       Ch := ReadKey;
		       if Ch = 'O' then    { La touche End a t frappe ! }
		       begin
			 LeaveGraphic;
			 Halt;
		       end;
		     end;
		   end;
    end; { case }
    J := J + 1;
    if J > 32767 then
      Ch := Cr;
  end; { while Ch <> Cr do }

  ChoixMenu := I;
end; { ChoixMenu }

procedure Factice2;
begin
end; { Factice2 }

procedure InfoSimple;
begin
  GotoXY(20, 5);
  WriteLn('Les commandes de dessin simples');
  GotoXY(10, 10); Write('Les commandes de dessin simples rendent possible la');
  GotoXY(10, 11); Write('ralisation de prsentations graphiques  partir de l''ide');
  GotoXY(10, 12); Write('que l''utilisateur s''en fait. Ces commandes se rapportent  la');
  GotoXY(10, 13); Write('fentre active. Le dessin n''est donc possible qu'' l''intrieur');
  GotoXY(10, 14); Write('de cette fentre. Le dessin dbordant de la fentre ne sera pas');
  GotoXY(10, 15); Write('affich. Cette caractristique peut tre dsactive pour une plus');
  GotoXY(10, 16); Write('grande souplesse d''utilisation. L''chelle est gre par TURBO');
  GotoXY(10, 17); Write('GRAPHIX. On peut donc dessiner dans n''importe quel systme de');
  GotoXY(10, 18); Write('coordonnes sans avoir  faire de calculs complexes. Un');
  GotoXY(10, 19); Write('systme de coordonnes diffrent peut tre appliqu  chaque');
  GotoXY(10, 20); Write('fentre dfinie.');
  GotoXY(31, 25);
  AttendReturn(60000.0);
  Simple;
end; { InfoSimple }

procedure InfoDemoFenetre;
begin
  GotoXY(20, 5);
  WriteLn('Utilisation des fentres');
  GotoXY(10, 8); Write('Le systme TURBO GRAPHIX permet de dfinir un nombre illimit');
  GotoXY(10, 9); Write('de fentres. Ces fentres reprsentent aprs dfinition la');
  GotoXY(10, 10); Write('vritable feuille de dessin. Toutes les oprations graphiques');
  GotoXY(10, 11); Write('pouvant tre excutes sur l''cran entier peuvent tre accomplies');
  GotoXY(10, 12); Write('dans une ou plusieurs fentres de la mme manire. De cette');
  GotoXY(10, 13); Write('faon, plusieurs oprations peuvent s''afficher sur un cran tout');
  GotoXY(10, 14); Write('en restant simples et claires.');
  GotoXY(10, 16); Write('Avec des commandes simples, les fentres peuvent tre dplaces');
  GotoXY(10, 17); Write(' l''cran et imprimes  un emplacement quelconque. Toute');
  GotoXY(10, 18); Write('fentre peut tre stocke dans une mmoire fentre indpendante');
  GotoXY(10, 19); Write('de l''cran et rapidement rcupre  tout endroit de l''cran.');
  GotoXY(10, 20); Write('La taille de cette mmoire n''est limite que par la taille');
  GotoXY(10, 21); Write('de la mmoire centrale.');
  GotoXY(31, 25);
  AttendReturn(60000.0);
  DemoFenetre;
end; { InfoDemoFenetre }

procedure InfoSpline;
begin
  GotoXY(20, 5); WriteLn('Utilisation des fonctions Spline');
  GotoXY(10, 10); Write('procdure : Spline(paramtre);');
  GotoXY(10, 13); Write('La procdure Spline permet de crer des courbes lisses.');
  GotoXY(10, 14); Write('Donnez un nombre de colonnes, choisissez les points de dpart');
  GotoXY(10, 15); Write('et de fin de l''interpolation, le nombre de points entre le');
  GotoXY(10, 16); Write('dbut et la fin, appelez Spline, puis dessinez les points ');
  GotoXY(10, 17); Write('l''aide de la procdure DrawPolygon.');
  GotoXY(10, 19); Write('Dans l''exemple suivant, les donnes (*) seront d''abord');
  GotoXY(10, 20); Write('prsentes, puis la fonction Spline cre (50 points) sera');
  GotoXY(10, 21); Write('affiche  l''cran (ligne dessine).');
  GotoXY(20, 25);
  AttendReturn(60000.0);
  DemSpline;
end; { InfoSpline }

procedure InfoSectoriel;
begin
  GotoXY(20, 5); WriteLn('Utilisation des diagrammes sectoriels');
  GotoXY(10, 8); Write('procdure : DrawCartPie ou DrawPolarPie(paramtre);');
  GotoXY(10, 10); Write('Les procdures DrawPie servent  crer des diagrammes sectoriels.');
  GotoXY(10, 11); Write('Pour crer un diagramme de ce type, donnez les coordonnes du');
  GotoXY(10, 12); Write('centre du cercle, le nombre de parts clates, le nombre total de');
  GotoXY(10, 13); Write('segments, un champ numrique et le texte de description. Texte et');
  GotoXY(10, 14); Write('chiffres peuvent tre affichs ensemble ou sparment. L''exemple');
  GotoXY(10, 15); Write('qui suit commence par lister les donnes de base du diagramme.');
  GotoXY(10, 16); Write('Au mme moment, un diagramme est dessin sur le second cran');
  GotoXY(10, 17); Write('du fond, puis il est recopi au dessus du premier cran. Ensuite');
  GotoXY(10, 18); Write('viennent plusieurs variations de cette mme opration.');
  GotoXY(20, 25);
  AttendReturn(60000.0);
  DemSectoriel;
end; { InfoSectoriel }

procedure InfoBezier;
begin
  GotoXY(10, 5); WriteLn('Utilisation de la fonction BEZIER pour dessiner');
  GotoXY(3, 8); Write('procdure : Bezier(paramtre);');
  GotoXY(3, 10); Write('La procdure bezier cre des objets lisss en deux dimensions ');
  GotoXY(3, 11); Write('partir de points fournis par l''utilisateur. Elle peut aussi');
  GotoXY(3, 12); Write('dessiner des courbes de courbure ample et ajuster des polynmes.');
  GotoXY(3, 13); Write('L''exemple qui suit dessine 7 points (carr clairs) et leur');
  GotoXY(3, 14); Write('fonction BEZIER respective (ligne dessine). La position de');
  GotoXY(3, 15); Write('chaque point peut tre modifie en entrant le numro du point ');
  GotoXY(3, 16); Write('changer (de 1  7) et ses nouvelles coordonnes. La procdure');
  GotoXY(3, 17); Write('bezier crera alors la fonction BEZIER de ce point. Vous pouvez');
  GotoXY(3, 18); Write('quitter ce module en tapant RETURN  la demande du numro du');
  GotoXY(3, 19); Write('point.');
  GotoXY(20, 25);
  AttendReturn(60000.0);
  DemBezier;
end; { InfoBezier }

procedure InfoGraphe;
begin
  GotoXY(10, 5); WriteLn('Possibilits des diagrammes polynmiaux');
  GotoXY(3, 8); Write('Commande : DrawPolygon(paramtre);');
  GotoXY(3, 10); Write('La commande DrawPolygon sert au dessin des graphes. La procdure');
  GotoXY(3, 11); Write('DrawPolygon lie les sommets d''un graphe par diffrents types');
  GotoXY(3, 12); Write('de lignes, marque les coins de diffrents symboles, tels');
  GotoXY(3, 13); Write('que des toiles, des carrs, des barres obliques, etc., cre');
  GotoXY(3, 14); Write('des barres, et beaucoup d''autres choses. Par des dessins rpts');
  GotoXY(3, 15); Write('dans la mme fentre, les graphes peuvent s''empiler.');
  GotoXY(3, 16); Write('Tous les diagrammes peuvent tre dessins avec ou sans les');
  GotoXY(3, 17); Write('coordonnes et le texte.');
  GotoXY(3, 19); Write('Les exemples suivants sont tous crs avec la commande DrawPolygon');
  GotoXY(3, 20); Write('en variant les paramtres.  Avec la commande DrawAxis, une');
  GotoXY(3, 21); Write('prsentation des axes intgrant du texte est possible.');
  GotoXY(3, 23); Write('Utilisez la touche RETURN pour vous dplacer  l''intrieur de ce');
  GotoXY(3, 24); Write('module.');
  GotoXY(20, 25);
  AttendReturn(60000.0);
  DemGraphe;
end; { InfoGraphe }

var
  Choix : integer;

begin { DemoGraphiquesTurbo }
  CheckBreak := false;
  InitGraphic;
  SetBreakOn;
  SetMessageOn;
  SetHeaderOn;
  DefineWorld(2, 0, 199, 639, 0);
  DefineWindow(10, 0, 0, XMaxGlb, YMaxGlb);
  Intro;
  Choix := 0;
  repeat
    ClearScreen;
    ResetWindowStack;
    ResetWindows;
    ResetWorlds;
    DefineWorld(2, 0, 199, 639, 0);
    DefineWindow(10, 0, 0, XMaxGlb, YMaxGlb);
    SelectWorld(2);
    SelectWindow(10);
    SetAspect(1.0);
    Choix := ChoixMenu(Choix);
    ClearScreen;
    case Choix of
      1 : InfoDemoFenetre;
      2 : InfoSimple;
      3 : Sier;
      4 : InfoSectoriel;
      5 : InfoSpline;
      6 : InfoGraphe;
      7 : DemHisto;
      8 : DemOrganigramme;
      9 : InfoBezier;
    end;
  until Choix = 0;
  LeaveGraphic;
end. { DemoGraphiquesTurbo }
